<template>
    <div class="p-4 w-full" :class="cardSize">
        <div class="h-full border-2 border-gray-200 rounded-lg overflow-hidden relative hover:bg-shark-100 hover:bg-opacity-60">
            <div v-if="record.content">
                <g-link :to="record.link">
                    <img class="thumbnail" :src="thumbnail" />
                </g-link>
            </div>
            <div v-if="isYoutubeVideo">
                <iframe width="420" height="315" :src="embeddedYoutube"></iframe>
            </div>
            <div class="p-6">
                <div class="text-smalt-blue-700 mb-3 text-left text-xs font-bold">
                    {{ humanReadableDate(record.pubDate) }}
                </div>
                <hr class="mb-3" />
                <h2 class="title-font text-2xl font-medium text-gray-900 mb-3 text-left leading-7" :class="{ 'mb-12': !record.content }">
                    <g-link :to="record.link" class="">
                        {{ record.title }}
                    </g-link>
                </h2>
                <div v-if="record.content" class="leading-relaxed mb-12 text-gray-800 text-left" v-html="truncateContent" />
                <div class="flex items-center flex-wrap absolute bottom-0 -ml-6 p-6 w-full">
                    <div class="text-left">
                        <span v-for="category in record.categories" :key="category" class="badge-category">
                            {{ category }}
                        </span>
                    </div>
                </div>
                <div></div>
            </div>
        </div>
    </div>
</template>

<script>
    import { format } from 'date-fns';

    export default {
        computed: {
            truncateContent() {
                return this.record.content.slice(0, 100) + ' [...]';
            },
            thumbnail() {
                return this.record.contentHtml.match(/<img[^>]+src="([^">]+)"/)[1];
            },
            isYoutubeVideo() {
                return this.record.id && this.record.id.includes('yt:video:');
            },
            embeddedYoutube() {
                return this.isYoutubeVideo ? 'https://www.youtube-nocookie.com/embed/' + this.record.id.split(':')[2] : '';
            },
        },
        methods: {
            humanReadableDate(date) {
                return format(new Date(date), 'MMMM do yyyy');
            },
        },
        props: {
            cardSize: {
                type: String,
                default: 'sm:w-1/2 lg:w-1/3',
            },
            record: {
                type: Object,
                default() {
                    return {};
                },
            },
        },
    };
</script>
<style scoped lang="scss">
    .thumbnail {
        height: 220px;
        width: 100%;
        object-fit: cover;
    }
    .badge-category {
        background-color: #fff4f4;
        color: #ff7370;
        display: inline-block;
        vertical-align: middle;
        box-sizing: border-box;
        border-radius: 2px;
        white-space: nowrap;
        margin-right: 5px;
        padding: 2px;
        font-size: 0.7rem;
    }
</style>
